package lark

import (
	"context"
	cfg "git.icechen.cn/monorepo/backend/app/zeus/service/lark/internal/config"
	"github.com/larksuite/oapi-sdk-go/core"
	"github.com/larksuite/oapi-sdk-go/core/config"
	authen "github.com/larksuite/oapi-sdk-go/service/authen/v1"
)

type Lark struct {
	conf *config.Config
}

var lark Lark

func Client() Lark {
	if lark.conf == nil {
		appSettings := core.NewInternalAppSettings(
			core.SetAppCredentials(cfg.Config.LarkAppID, cfg.Config.LarkAppSecret))
		lark.conf = core.NewConfig(core.DomainFeiShu, appSettings, core.SetLoggerLevel(core.LoggerLevelError))
	}
	return lark
}

func (l Lark) Auth(code string) (*authen.UserAccessTokenInfo, error) {
	s := authen.NewService(l.conf)
	return s.Authens.AccessToken(core.WrapContext(context.Background()), &authen.AuthenAccessTokenReqBody{
		GrantType: "",
		Code:      code,
	}).Do()
}
